import java.util.Iterator;

public class ArrayBasedQueueDriver {

	public static void main(String[] args) {
		ArrayBasedQueue<Integer> abq = new ArrayBasedQueue<Integer>();
		
		for ( int i = 1 ; i <= 10 ; i++ ) {
			abq.enqueue(i);
		}
		
		System.out.println(abq);
		
		System.out.println("Peek = " + abq.peek());
		
		System.out.println("Dequeued Element = " + abq.dequeue());
		System.out.println(abq);

		System.out.println("Dequeued Element = " + abq.dequeue());
		System.out.println(abq);
		
		abq.enqueue(11);
		System.out.println(abq);
		
		abq.enqueue(12);
		System.out.println(abq);
		
		try {
			abq.enqueue(13);
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
		
		try {
			abq.enqueue(null);
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
		
		System.out.println("Peek = " + abq.peek());
		
		System.out.println("Dequeued Element = " + abq.dequeue(4));
		System.out.println(abq);
		
		System.out.println("Dequeued Element = " + abq.dequeue(5));
		System.out.println(abq);
		
		System.out.println("Dequeued Element = " + abq.dequeue(0));
		System.out.println(abq);
		
		System.out.println("Dequeued Element = " + abq.dequeue());
		System.out.println(abq);
		
		System.out.println("Dequeued Element = " + abq.dequeue(5));
		System.out.println(abq);
		
		Iterator<Integer> iter = abq.iterator();
		
		while (iter.hasNext()) {
			System.out.println("Iterator element = " + iter.next());
		}
		
	}

}
